• codeforces 490 D Chocolate


    题意:给出a1*b1和a2*b2两块巧克力,每次可以将这四个数中的随意一个数乘以1/2或者2/3,前提是要可以被2或者3整除,要求最小的次数让a1*b1=a2*b2,并求出这四个数最后的大小。




    做法:非常显然仅仅跟2跟3有关。所以s1=a1*b1,s2=a2*b2,s1/=gcd(s1,s2),s2/=gcd(s1,s2),然后若s1跟s2的质因子都是2跟3,那么就有解。之后暴力乱搞就好了。


    #include<map>
    #include<string>
    #include<cstring>
    #include<cstdio>
    #include<cstdlib>
    #include<cmath>
    #include<queue>
    #include<vector>
    #include<iostream>
    #include<algorithm>
    #include<bitset>
    #include<climits>
    #include<list>
    #include<iomanip>
    #include<stack>
    #include<set>
    using namespace std;
    typedef long long ll;
    ll gcd(ll a,ll b)
    {
    	return b==0?a:gcd(b,a%b);
    }
    bool work(ll x,int *cnt)
    {
    	while(x%2==0)
    	{
    		x/=2;
    		cnt[2]++;
    	}
    	while(x%3==0)
    	{
    		x/=3;
    		cnt[3]++;
    	}
    	return x==1;
    }
    void cg(int &a,int &b,int val,int num)
    {
    	while(a%val==0&&num>0)
    	{
    		num--;
    		a/=val;
    		if(val==3)
    			a*=2;
    	}
    	while(b%val==0&&num>0)
    	{
    		num--;
    		b/=val;
    		if(val==3)
    			b*=2;
    	}
    }
    int num[2][4];
    int a[2],b[2];
    ll s[2];
    int main()
    {
    	for(int i=0;i<2;i++)
    	{
    		cin>>a[i]>>b[i];
    		s[i]=ll(a[i])*b[i];
    	}
    	ll t=gcd(s[0],s[1]);
    	s[0]/=t;s[1]/=t;
    	if(!work(s[0],num[0])||!work(s[1],num[1]))
    	{
    		puts("-1");
    		return 0;
    	}
    	int ans=0;
    	for(int i=3;i>1;i--)
    	{
    		int sub=abs(num[0][i]-num[1][i]);
    		ans+=sub;
    		if(num[0][i]>num[1][i])
    		{
    			num[0][i-1]+=sub;
    			cg(a[0],b[0],i,sub);
    		}
    		else
    		{
    			num[1][i-1]+=sub;
    			cg(a[1],b[1],i,sub);
    		}
    	}
    	printf("%d
    %d %d
    %d %d",ans,a[0],b[0],a[1],b[1]);
    }


    D. Chocolate
    time limit per test
    1 second
    memory limit per test
    256 megabytes
    input
    standard input
    output
    standard output

    Polycarpus likes giving presents to Paraskevi. He has bought two chocolate bars, each of them has the shape of a segmented rectangle. The first bar is a1 × b1 segments large and the second one is a2 × b2 segments large.

    Polycarpus wants to give Paraskevi one of the bars at the lunch break and eat the other one himself. Besides, he wants to show that Polycarpus's mind and Paraskevi's beauty are equally matched, so the two bars must have the same number of squares.

    To make the bars have the same number of squares, Polycarpus eats a little piece of chocolate each minute. Each minute he does the following:

    • he either breaks one bar exactly in half (vertically or horizontally) and eats exactly a half of the bar,
    • or he chips of exactly one third of a bar (vertically or horizontally) and eats exactly a third of the bar.

    In the first case he is left with a half, of the bar and in the second case he is left with two thirds of the bar.

    Both variants aren't always possible, and sometimes Polycarpus cannot chip off a half nor a third. For example, if the bar is 16 × 23, then Polycarpus can chip off a half, but not a third. If the bar is 20 × 18, then Polycarpus can chip off both a half and a third. If the bar is 5 × 7, then Polycarpus cannot chip off a half nor a third.

    What is the minimum number of minutes Polycarpus needs to make two bars consist of the same number of squares? Find not only the required minimum number of minutes, but also the possible sizes of the bars after the process.

    Input

    The first line of the input contains integers a1, b1 (1 ≤ a1, b1 ≤ 109) — the initial sizes of the first chocolate bar. The second line of the input contains integers a2, b2 (1 ≤ a2, b2 ≤ 109) — the initial sizes of the second bar.

    You can use the data of type int64 (in Pascal), long long (in С++), long (in Java) to process large integers (exceeding 231 - 1).

    Output

    In the first line print m — the sought minimum number of minutes. In the second and third line print the possible sizes of the bars after they are leveled in m minutes. Print the sizes using the format identical to the input format. Print the sizes (the numbers in the printed pairs) in any order. The second line must correspond to the first bar and the third line must correspond to the second bar. If there are multiple solutions, print any of them.

    If there is no solution, print a single line with integer -1.

    Sample test(s)
    input
    2 6
    2 3
    
    output
    1
    1 6
    2 3
    
    input
    36 5
    10 16
    
    output
    3
    16 5
    5 16
    
    input
    3 5
    2 1
    
    output
    -1
    


  • 相关阅读:
    [树状数组]JZOJ 4658 小Z调顺序
    [差分数组]JZOJ 3187 的士
    [BFS]JZOJ 4671 World Tour
    [BFS]JZOJ 4672 Graph Coloring
    [数学]JZOJ 4673 LCS again
    shell:正则表达式和文本处理器
    开发脚本自动部署及监控
    Linux中的重启命令
    nginx和nfs
    网络相关配置
  • 原文地址:https://www.cnblogs.com/lxjshuju/p/7057700.html
Copyright © 2020-2023  润新知